"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const react_1 = (0, tslib_1.__importDefault)(require("react"));
const Form_1 = (0, tslib_1.__importDefault)(require("../Form"));
const Field_1 = (0, tslib_1.__importDefault)(require("../Field"));
const index_1 = (0, tslib_1.__importDefault)(require("./index"));
const prop_types_1 = (0, tslib_1.__importDefault)(require("prop-types"));
const Object_1 = (0, tslib_1.__importDefault)(require("../Object"));
const react_2 = require("@testing-library/react");
require("@testing-library/jest-dom");
class DummyInput extends react_1.default.Component {
    render() {
        return (react_1.default.createElement("input", { value: this.props.value || '', onChange: event => {
                this.props.onChange(event.target.value);
            } }));
    }
}
DummyInput.propTypes = {
    value: prop_types_1.default.string,
    onChange: prop_types_1.default.func
};
it('should pass the value of the form', () => {
    (0, react_2.render)(react_1.default.createElement(Form_1.default, { state: { name: 'Nicolás' } },
        react_1.default.createElement(index_1.default, null, value => (react_1.default.createElement("div", null,
            react_1.default.createElement("div", { className: "theValue" }, value.name),
            react_1.default.createElement(Field_1.default, { fieldName: "name", type: DummyInput }))))));
    const content = react_2.screen.getByText('Nicolás');
    expect(content.innerHTML).toBe('Nicolás');
});
it('should pass the value of the form on sub object data', () => {
    const doc = { person: { name: 'Nicolás' } };
    (0, react_2.render)(react_1.default.createElement(Form_1.default, { state: doc },
        react_1.default.createElement(Field_1.default, { fieldName: "person", type: Object_1.default },
            react_1.default.createElement(index_1.default, null, person => (react_1.default.createElement("div", null,
                react_1.default.createElement("div", { className: "theValue" }, person.name),
                react_1.default.createElement(Field_1.default, { fieldName: "name", type: DummyInput })))))));
    const content = react_2.screen.getByText('Nicolás');
    expect(content.innerHTML).toBe('Nicolás');
});
//# sourceMappingURL=index.test.js.map